import java.math.* ;
/*
  QS

 Luc Maranget, projet Moscova, Inria Rocquencourt
 
 Copyright 2005 Institut National de Recherche en Informatique et    
 en Automatique.  All rights reserved.  This file is distributed     
 under the terms of the Q Public License version 1.0.          
*/
class Trial {

  static int trial(BigInteger n, int [] p, int i) {
    int sz = p.length ;
    for ( ; i < sz ; i++) {
      BigInteger pp = BigInteger.valueOf(p[i]) ;
      if (BigInteger.ZERO.equals(n.mod(pp))) {
        return p[i] ;
      }
    }
    return 0 ;
  }

  static int algo(BigInteger n) {
    if (0 == n.mod(BigInteger.valueOf(2)).signum()) return 2 ;
    int p = 3 ;
    for ( ; ; p += 2) {
      BigInteger pp = BigInteger.valueOf(p) ;
      BigInteger [] qr = n.divideAndRemainder(pp) ;
      BigInteger q = qr[0] ;
      BigInteger r = qr[1] ;
      if (r.signum() == 0) {
        return p ;
      } else if (q.compareTo(pp) < 0) {
        return 0 ;
      }
    }
  }

  static BigInteger roots(BigInteger n, BigInteger sqrtn, int downto) {
    if (n.mod(sqrtn).signum() == 0) return sqrtn ;
    Primes p = new Primes () ;
    BigInteger d = BigInteger.valueOf(downto) ;
    p.next() ; p.next() ; // get rid of first two primes -1 and 2

    for (BigInteger t = Arith.nrt(n, p.next()) ; t.compareTo(d) > 0 ;
         t = Arith.nrt(n, p.next())) {
      if (n.mod(t).signum() == 0) return t ;
    }
    return null ;
  }
}
